program terminal;

uses crt,dos,printer;

const
  TxDataReg = 0;
  RxDataReg = 0;
  DivLow = 0;
  DivHigh = 1;
  IntrEnable = 1;
  IntrId = 2;
  FifoCtrl = 2;
  LineCtrl = 3;
  ModemCtrl = 4;
  LineStatus = 5;
  ModemStatus = 6;
  ScratchReg = 7;

const
  QueueLen = 1024;

type
  TQueue = record
    Content: array[0..QueueLen - 1] of byte;
    Start: word;
    Stop: word;
    end;

type
  TQuadString = string[4];

var
fr,fw:file of byte;
g,h,e:text;
i,j,k,l,wait,code:word;
timeout,datpoz,podm,podm2,a,pom_i:integer;
ibutton,datum,datum2,s1,s2,s3,s4,s5:string;
cisport,server,typ_s,kod_s,typpr,httphost,waits,czkey,extprg:string;
zapis,cykl,bpk,bp2:byte;
dirinfo:searchrec;
znak:char;
disk,tmp,stopa,sektor,dma:word;
pozice:longint;


InQueue: TQueue;
OutQueue: TQueue;
cas,c:byte;
B: char;
view,typpak,pis,cispak,lenpak:byte;
d:array[1..200] of byte;
typ,kod,prace:integer;
karta:string;
zapdisk:array[1..400] of byte;
zapstopa:array[1..400] of byte;
zapsektor:array[1..400] of byte;
zapdata:array[1..400,1..128] of byte;
zapisuji:word;


const
  SpeedCount = 19;

const
  AllowedSpeeds: array[0..SpeedCount] of longint =
    (    50,      75,    110,    150,    300,    600,     900,    1200,
       1800,    2400,   3600,   4800,   7200,   9600,   14400,   19200,
      28800,   38400,  57600, 115200);
var
  PortNr: byte;
  PortBase: word;
  Speed: longint;
  UARTType: byte;
  UsedIRQ: byte;



procedure SendEOI; assembler;
asm
        mov     al, 20h
        out     20h, al
end;

function GetPortBase(N: byte): word; assembler;
asm
        mov     ax, 0040h
        mov     es, ax
        xor     ax, ax
        mov     al, N
        dec     al
        shl     ax, 1
        mov     si, ax
        mov     ax, es:[si]
end;

procedure SetIntVec(N: byte; P: pointer); assembler;
asm
        push    ds
        mov     ah, 25h
        mov     al, N
        lds     dx, P
        int     21h
        pop     ds
end;

function GetIntVec(N: byte): pointer; assembler;
asm
        push    es
        mov     ah, 35h
        mov     al, N
        int     21h
        mov     ax, bx
        mov     dx, es
        pop     es
end;

procedure ResetQueue(var Q: TQueue);
begin
  Q.Start := 0;
  Q.Stop := 0;
end;

procedure PutQueueByte(var Q: TQueue; B: byte);
begin
  Q.Content[Q.Stop] := B;

  inc(Q.Stop);
  if (Q.Stop = QueueLen) then
    Q.Stop := 0;

end;

function GetQueueByte(var Q: TQueue; var B: byte): boolean;
begin
  if (Q.Stop = Q.Start) then
    GetQueueByte := false
  else
    begin
      GetQueueByte := true;
      B := Q.Content[Q.Start];
      inc(Q.Start);
      if (Q.Start = QueueLen) then
        Q.Start := 0;
    end;
end;

procedure SerialInterrupt; interrupt;
var
  Id: byte;
  Trash: byte;
begin
  repeat
    Id := Port[PortBase + IntrId];

    if ((Id and 1) = 0) then
      begin

        case ((Id and 6) shr 1) of
          $03:
            begin
              Trash := Port[PortBase + LineStatus];
            end;
          $02:
            begin
              Trash := Port[PortBase + RxDataReg];
              PutQueueByte(InQueue, Trash);
            end;
          $01:
            begin
              if (GetQueueByte(OutQueue, Trash)) then
                Port[PortBase + TxDataReg] := Trash
              else
                Port[PortBase + IntrEnable] := $0D;

            end;
          $00:
            begin
              Trash := Port[PortBase + ModemStatus];
            end;
          end;
        end;

  until ((Id and 1) = 1);
  SendEOI;
end;

procedure SendChar(C: char);
var sci:byte;
begin
  delay(2);
  PutQueueByte(OutQueue, byte(C));
  Port[PortBase + IntrEnable] := $0F;
{  for sci:=1 to 5 do delay(1);}
end;

const
  UART_Bad = 0;
  UART_8250 = 1;
  UART_16450 = 2;
  UART_16550 = 3;
  UART_16550A = 4;

function GetUARTType(Base: word): byte; assembler;
asm
        mov     dx, Base
        add     dx, ScratchReg
        mov     al, 0AAh
        out     dx, al
        in      al, dx
        cmp     al, 0AAh
        je      @@1
        mov     ax, UART_8250
        jmp     @@5
@@1:    mov     dx, Base
        add     dx, FifoCtrl
        mov     al, 01h
        out     dx, al
        nop
        mov     dx, Base
        add     dx, IntrId
        in      al, dx
        and     al, 0C0h
        cmp     al, 0C0h
        jne     @@2
        mov     al, UART_16550A
        jmp     @@5
@@2:    cmp     al, 80h
        jne     @@3
        mov     al, UART_16550
        jmp     @@5
@@3:    cmp     al, 0
        jne     @@4
        mov     al, UART_16450
        jmp     @@5
@@4:    mov     al, UART_Bad
@@5:    nop
end;

procedure UpCaseStr(var S: string); assembler;
asm
        les     di, S
        xor     cx, cx
        mov     cl, es:[di]
        inc     di
@@1:    mov     al, es:[di]
        cmp     al, 'a'
        jb      @@2
        cmp     al, 'z'
        ja      @@2
        sub     al, 20h
@@2:    mov     es:[di], al
        inc     di
        loop    @@1
end;

function IsAllowedSpeed(Speed: longint): boolean;
var
  I: byte;
begin
  IsAllowedSpeed := false;

  for I := 0 to SpeedCount do
    if (AllowedSpeeds[I] = Speed) then
      begin
        IsAllowedSpeed := true;
        exit;
      end;

end;

procedure GetCommandLine(var PortId: byte; var Speed: longint);
var
  S: string;
  I: byte;
  J: integer;
begin
{  if (ParamCount=0) then begin
      writeln('Musite jako parametr zadat cislo portu COM1, COM2, COM3 nebo COM4.');
      halt;
    end;}

  S := cisport;

{  for I := 1 to ParamCount do
    S := S + ParamStr(I);}

  UpCaseStr(S);

  if (copy(S, 1, 3)<>'COM') then
    begin
      writeln('Chyba parametru. Parametrem musi byt nazev portu COM1, COM2 ...');
      halt;
    end;

  I := byte(S[4]) - ord('0');

  if (i>4) then
    begin
      writeln('Spatne zadany COM port.');
      halt;
    end
  else
    PortId := I;

  Speed:=4800;

end;

procedure EnableIRQ(IRQ: byte); assembler;
asm
        mov     cl, IRQ
        mov     bl, 1
        shl     bl, cl
        mov     ah, 255
        sub     ah, bl
        in      al, 21h
        and     al, ah
        out     21h, al
end;

procedure DisableIRQ(IRQ: byte); assembler;
asm
        mov     cl, IRQ
        mov     bl, 1
        shl     bl, cl
        in      al, 21h
        or      al, bl
        out     21h, al
end;

procedure PrintChar(Character: char); assembler;
asm
        mov     ah, 0Eh
        mov     al, Character
        xor     bh, bh
        mov     bl, 07h
        int     10h
end;

var
  OldInterruptVec: pointer;

procedure SetupPort(PortBase: word; Speed: longint; IRQ: byte);
var
  D: word;
  B: byte;
begin
  DisableIRQ(IRQ);

  OldInterruptVec := GetIntVec($08 + IRQ);
  SetIntVec($08 + IRQ, @SerialInterrupt);

  Port[PortBase + IntrEnable] := $01;

  repeat
    B := Port[PortBase + RxDataReg];
    B := Port[PortBase + LineStatus];
    B := Port[PortBase + ModemStatus];

  until ((Port[PortBase + IntrId] and 1) = 1);

  EnableIRQ(IRQ);

  D := (115200 div Speed);

  Port[PortBase + LineCtrl] := $80;
  Port[PortBase + DivLow] := Lo(D);
  Port[PortBase + DivHigh] := Hi(D);

  Port[PortBase + LineCtrl] := $03;
  Port[PortBase + ModemCtrl] := $0B;
  Port[PortBase + IntrEnable] := $0F;

  if (UARTType = UART_16550A) then
    begin
      Port[PortBase + FifoCtrl] := $07;

      Port[PortBase + FifoCtrl] := $C1;

    end;
end;

procedure ResetPort(PortBase: word; IRQ: byte);
begin
  Port[PortBase + LineCtrl] := Port[PortBase + LineCtrl] and $7F;
  Port[PortBase + ModemCtrl] := 0;
  Port[PortBase + IntrEnable] := 0;

  DisableIRQ(IRQ);
  SetIntVec($08 + IRQ, OldInterruptVec);

end;

function Hex(W: word): TQuadString;
const
  HexChars: array[0..15] of char = '0123456789ABCDEF';
begin
  Hex := HexChars[W shr 12] +
         HexChars[(W shr 8) and 15] +
         HexChars[(W shr 4) and 15] +
         HexChars[W and 15];
end;

procedure WritePortInfo;
begin
  write('Pouzit COM', PortNr, ' (base address ', Hex(PortBase), ', IRQ ', UsedIRQ);
  write(', UART je ');

  case UARTType of
    UART_8250:
      write('8250');
    UART_16450:
      write('16450');
    UART_16550:
      write('16550');
    UART_16550A:
      write('16550A');
    end;

  writeln(')...');
end;



procedure ctic;
var ctich,cticm,ctics,ctics2,cticss:word;
begin
gettime(ctich,cticm,ctics2,cticss); ctics:=70;
ctics2:=ctics2+3; if ctics2>59 then ctics2:=ctics2-60;
while (not (GetQueueByte(InQueue, byte(c))) and (ctics2<>ctics)) do
  begin
  gettime(ctich,cticm,ctics,cticss);
  end;
if ctics2=ctics then timeout:=1 else timeout:=0;
end;



begin

textcolor(white); clrscr;
PortNr:=1; Speed:=57600;
PortBase := GetPortBase(PortNr);
if (PortBase = 0) then
  begin
    writeln('COM', PortNr, ': neni COM port');
    halt;
  end;
UsedIRQ := 4 - ((PortNr - 1) and 1);
UARTType := GetUARTType(PortBase);
ResetQueue(InQueue);
ResetQueue(OutQueue);
ResetPort(PortBase, UsedIRQ);
SetupPort(PortBase, Speed, UsedIRQ);

writeln('Odeslat Mikros? (A..odesle mikros, N..skok na emulaci disku)');
repeat until KeyPressed;
znak:=readkey;
if ((znak='a') or (znak='A')) then
  begin
  b:=char(240); sendchar(b); delay(200);  {nastavi x51 na KBD}
  b:=char(1); sendchar(b); delay(200);
  b:='S'; sendchar(b); delay(200);
  b:='F'; sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:='3'; sendchar(b); delay(200);
  b:='7'; sendchar(b); delay(200);
  b:=char(10); sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:='5'; sendchar(b); delay(200);
  b:='1'; sendchar(b); delay(200);
  b:='D'; sendchar(b); delay(200);
  b:=char(10); sendchar(b); delay(200);
  Writeln('Posilam pridavek biosu do planu...');
  b:='S'; sendchar(b); delay(200);
  b:='E'; sendchar(b); delay(200);
  b:='8'; sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:=char(10); sendchar(b); delay(200);
  assign(fr,'bios_add.bin'); reset(fr);
  k:=filesize(fr);
  for l:=1 to k do
      begin
      read(fr,bpk);
      i:=trunc(bpk/16);
      b:=char(i+48);
      if i=10 then b:='A';
      if i=11 then b:='B';
      if i=12 then b:='C';
      if i=13 then b:='D';
      if i=14 then b:='E';
      if i=15 then b:='F';
      write(b); sendchar(b); delay(200);
      i:=bpk-i*16;
      b:=char(i+48);
      if i=10 then b:='A';
      if i=11 then b:='B';
      if i=12 then b:='C';
      if i=13 then b:='D';
      if i=14 then b:='E';
      if i=15 then b:='F';
      write(b,'  '); sendchar(b); delay(250);
      end;
  close(fr);
  b:=char(10); sendchar(b); delay(400);
  Writeln; writeln;
  Writeln('Posilam zavadec mikrosu do planu...');
  b:='S'; sendchar(b); delay(200);
  b:='E'; sendchar(b); delay(200);
  b:='9'; sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:=char(10); sendchar(b); delay(200);
  assign(fr,'mik_load.bin'); reset(fr);
  k:=filesize(fr);
  for l:=1 to k do
      begin
      read(fr,bpk);
      i:=trunc(bpk/16);
      b:=char(i+48);
      if i=10 then b:='A';
      if i=11 then b:='B';
      if i=12 then b:='C';
      if i=13 then b:='D';
      if i=14 then b:='E';
      if i=15 then b:='F';
      write(b); sendchar(b); delay(200);
      i:=bpk-i*16;
      b:=char(i+48);
      if i=10 then b:='A';
      if i=11 then b:='B';
      if i=12 then b:='C';
      if i=13 then b:='D';
      if i=14 then b:='E';
      if i=15 then b:='F';
      write(b,'  '); sendchar(b); delay(250);
      end;
  close(fr);
  b:=char(10); sendchar(b); delay(200);
  b:='S'; sendchar(b); delay(200);
  b:='F'; sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:='3'; sendchar(b); delay(200);
  b:='7'; sendchar(b); delay(200);
  b:=char(10); sendchar(b); delay(200);
  b:='1'; sendchar(b); delay(200);
  b:='E'; sendchar(b); delay(200);
  b:='2'; sendchar(b); delay(200);
  b:='D'; sendchar(b); delay(200);
  b:=char(10); sendchar(b); delay(200);
  writeln; writeln('Odeslano ',k,' bytu.');
  writeln; writeln('Spoustim zavadec mikrosu.');
  b:='G'; sendchar(b); delay(200);
  b:='E'; sendchar(b); delay(200);
  b:='9'; sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:='0'; sendchar(b); delay(200);
  b:=char(10); sendchar(b); delay(200);
  b:=char(240); sendchar(b); delay(150);  {nastavi x51 na bmnet}
  b:=char(2); sendchar(b); delay(150);
  writeln; write('Posilam mikros ');
  assign(fr,'mikros58.bin'); reset(fr);
  k:=filesize(fr);
  writeln(k,' bytu');
  for l:=1 to k do
    begin
    read(fr,bpk); write(bpk,''); b:=char(bpk); sendchar(b);
    if bpk=240 then
      begin
      delay(20);  sendchar(b);
      end;
    while (not(GetQueueByte(InQueue, byte(c)))) do bpk:=bpk;
    write('.');
    end;
  close(fr);
end else begin
  b:=char(240); sendchar(b); delay(150);
  b:=char(2); sendchar(b); delay(150);
  end;

writeln; writeln('Spoustim emulaci disku (exit klavesou).');
zapisuji:=0;
repeat
  begin
  for i:=1 to 8 do
    begin
    while (not(GetQueueByte(InQueue, byte(c)))) do bpk:=bpk;
    if i=1 then disk:=c;
    if i=2 then tmp:=c;
    if i=3 then stopa:=c;
    if i=5 then sektor:=c;
    if i=7 then dma:=c;
    if i=8 then dma:=dma+256*c;
    write(c,' ');
    end;
  writeln; zapis:=0;
  if (disk>127) then
    begin
    zapis:=1; write('ZAPIS: ');
    disk:=disk-128;
    end else write('Cteni: ');
  write('Disk:',disk,' ','tmp:',tmp,' ','Stopa:',stopa,' ');
  writeln('Sektor:',sektor,' ','DMA:',dma);
  if disk=0 then assign(fr,'diska.p32');
  if disk=1 then assign(fr,'diskb.p32');
  if ((zapis=0) and (zapisuji<>0)) then
    begin
    writeln; writeln('-- Ukladam na disk PC ',zapisuji,' sektoru --');
    for l:=1 to zapisuji do
      begin
      if zapdisk[l]=0 then assign(fr,'diska.p32');
      if zapdisk[l]=1 then assign(fr,'diskb.p32');
      reset(fr);
      k:=filesize(fr); j:=0;
      assign(fw,'disk.tmp');
      rewrite(fw); reset(fr);
      pozice:=(zapstopa[l]*36+zapsektor[l]-1)*128;
      if (pozice>0) then for i:=1 to pozice do
        begin
        read(fr,bpk); write(fw,bpk); j:=j+1;
        end;
      for i:=1 to 128 do
        begin
        c:=zapdata[l,i];
        write(fw,c); j:=j+1; read(fr,bpk);
        end;
      while j<k do
        begin
        read(fr,bpk); write(fw,bpk); j:=j+1;
        end;
      close(fr); close(fw);  erase(fr);
      if zapdisk[l]=0 then rename(fw,'diska.p32');
      if zapdisk[l]=1 then rename(fw,'diskb.p32');
      write('.');
      end;
    writeln('-- Zapis OK --');
    if disk=0 then assign(fr,'diska.p32');
    if disk=1 then assign(fr,'diskb.p32');
    zapisuji:=0;
    end;
  if zapis=0 then
      begin
      reset(fr);
      pozice:=(stopa*36+sektor-1)*128;
      Seek(fr,pozice);
      for i:=1 to 128 do
        begin
        read(fr,bpk); {write(bpk,'');} b:=char(bpk); sendchar(b);
        if bpk=240 then
          begin
          delay(20);  sendchar(b);
          end;
        while (not(GetQueueByte(InQueue, byte(c)))) do bpk:=bpk;
        write('.');
        end;
      writeln;
      close(fr);
      end;
    if zapis=1 then
      begin
      zapisuji:=zapisuji+1;
      zapdisk[zapisuji]:=disk; zapstopa[zapisuji]:=stopa;
      zapsektor[zapisuji]:=sektor;
      for i:=1 to 128 do
        begin
        while (not(GetQueueByte(InQueue, byte(c)))) do bpk:=bpk;
        write(c,'.');
        zapdata[zapisuji,i]:=c;
        end;
      writeln;
      end;
    end;
  until KeyPressed;

b:=char(240); sendchar(b); delay(200);  {nastavi x51 na KBD}
b:=char(1); sendchar(b); delay(200);

ResetPort(PortBase, UsedIRQ);
end.
